<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Cancel_Purchase_Order_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Cancel Purchase Order Response
 * @subpackage Structs
 */
class Cancel_Purchase_Order_ResponseType extends AbstractStructBase
{
    /**
     * The Purchase_Order_Reference
     * Meta information extracted from the WSDL
     * - documentation: Canceled Purchase Order Reference
     * - minOccurs: 0
     * @var \StructType\Purchase_OrderObjectType
     */
    public $Purchase_Order_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Cancel_Purchase_Order_ResponseType
     * @uses Cancel_Purchase_Order_ResponseType::setPurchase_Order_Reference()
     * @uses Cancel_Purchase_Order_ResponseType::setVersion()
     * @param \StructType\Purchase_OrderObjectType $purchase_Order_Reference
     * @param string $version
     */
    public function __construct(\StructType\Purchase_OrderObjectType $purchase_Order_Reference = null, $version = null)
    {
        $this
            ->setPurchase_Order_Reference($purchase_Order_Reference)
            ->setVersion($version);
    }
    /**
     * Get Purchase_Order_Reference value
     * @return \StructType\Purchase_OrderObjectType|null
     */
    public function getPurchase_Order_Reference()
    {
        return $this->Purchase_Order_Reference;
    }
    /**
     * Set Purchase_Order_Reference value
     * @param \StructType\Purchase_OrderObjectType $purchase_Order_Reference
     * @return \StructType\Cancel_Purchase_Order_ResponseType
     */
    public function setPurchase_Order_Reference(\StructType\Purchase_OrderObjectType $purchase_Order_Reference = null)
    {
        $this->Purchase_Order_Reference = $purchase_Order_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Cancel_Purchase_Order_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
