<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Dispose_Asset_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Root element for the Response on the Dispose Asset operation.
 * @subpackage Structs
 */
class Dispose_Asset_ResponseType extends AbstractStructBase
{
    /**
     * The Asset_Disposal_Event_Reference
     * Meta information extracted from the WSDL
     * - documentation: A reference to the Asset Disposal Event that was created by the request.
     * - minOccurs: 0
     * @var \StructType\Unique_IdentifierObjectType
     */
    public $Asset_Disposal_Event_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Dispose_Asset_ResponseType
     * @uses Dispose_Asset_ResponseType::setAsset_Disposal_Event_Reference()
     * @uses Dispose_Asset_ResponseType::setVersion()
     * @param \StructType\Unique_IdentifierObjectType $asset_Disposal_Event_Reference
     * @param string $version
     */
    public function __construct(\StructType\Unique_IdentifierObjectType $asset_Disposal_Event_Reference = null, $version = null)
    {
        $this
            ->setAsset_Disposal_Event_Reference($asset_Disposal_Event_Reference)
            ->setVersion($version);
    }
    /**
     * Get Asset_Disposal_Event_Reference value
     * @return \StructType\Unique_IdentifierObjectType|null
     */
    public function getAsset_Disposal_Event_Reference()
    {
        return $this->Asset_Disposal_Event_Reference;
    }
    /**
     * Set Asset_Disposal_Event_Reference value
     * @param \StructType\Unique_IdentifierObjectType $asset_Disposal_Event_Reference
     * @return \StructType\Dispose_Asset_ResponseType
     */
    public function setAsset_Disposal_Event_Reference(\StructType\Unique_IdentifierObjectType $asset_Disposal_Event_Reference = null)
    {
        $this->Asset_Disposal_Event_Reference = $asset_Disposal_Event_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Dispose_Asset_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
