<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Get_Netting_Transactions_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Get Netting Transaction Response
 * @subpackage Structs
 */
class Get_Netting_Transactions_ResponseType extends AbstractStructBase
{
    /**
     * The Netting_Transaction_Request_References
     * Meta information extracted from the WSDL
     * - documentation: Get Netting Transaction Request References
     * - minOccurs: 0
     * @var \StructType\Netting_Transaction_Request_ReferencesType
     */
    public $Netting_Transaction_Request_References;
    /**
     * The Netting_Transaction_Request_Criteria
     * Meta information extracted from the WSDL
     * - documentation: Get Netting Transactions Request Criteria
     * - minOccurs: 0
     * @var \StructType\Netting_Transaction_Request_CriteriaType
     */
    public $Netting_Transaction_Request_Criteria;
    /**
     * The Response_Filter
     * Meta information extracted from the WSDL
     * - documentation: Response Filter
     * - minOccurs: 0
     * @var \StructType\Response_FilterType
     */
    public $Response_Filter;
    /**
     * The Response_Group
     * Meta information extracted from the WSDL
     * - documentation: Get Netting Transactions Response Group
     * - minOccurs: 0
     * @var \StructType\Netting_Transaction_Response_GroupType
     */
    public $Response_Group;
    /**
     * The Response_Results
     * Meta information extracted from the WSDL
     * - documentation: Response Results
     * - minOccurs: 0
     * @var \StructType\Response_ResultsType
     */
    public $Response_Results;
    /**
     * The Response_Data
     * Meta information extracted from the WSDL
     * - documentation: Netting Transaction
     * - minOccurs: 0
     * @var \StructType\Netting_Transaction_Response_DataType
     */
    public $Response_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Get_Netting_Transactions_ResponseType
     * @uses Get_Netting_Transactions_ResponseType::setNetting_Transaction_Request_References()
     * @uses Get_Netting_Transactions_ResponseType::setNetting_Transaction_Request_Criteria()
     * @uses Get_Netting_Transactions_ResponseType::setResponse_Filter()
     * @uses Get_Netting_Transactions_ResponseType::setResponse_Group()
     * @uses Get_Netting_Transactions_ResponseType::setResponse_Results()
     * @uses Get_Netting_Transactions_ResponseType::setResponse_Data()
     * @uses Get_Netting_Transactions_ResponseType::setVersion()
     * @param \StructType\Netting_Transaction_Request_ReferencesType $netting_Transaction_Request_References
     * @param \StructType\Netting_Transaction_Request_CriteriaType $netting_Transaction_Request_Criteria
     * @param \StructType\Response_FilterType $response_Filter
     * @param \StructType\Netting_Transaction_Response_GroupType $response_Group
     * @param \StructType\Response_ResultsType $response_Results
     * @param \StructType\Netting_Transaction_Response_DataType $response_Data
     * @param string $version
     */
    public function __construct(\StructType\Netting_Transaction_Request_ReferencesType $netting_Transaction_Request_References = null, \StructType\Netting_Transaction_Request_CriteriaType $netting_Transaction_Request_Criteria = null, \StructType\Response_FilterType $response_Filter = null, \StructType\Netting_Transaction_Response_GroupType $response_Group = null, \StructType\Response_ResultsType $response_Results = null, \StructType\Netting_Transaction_Response_DataType $response_Data = null, $version = null)
    {
        $this
            ->setNetting_Transaction_Request_References($netting_Transaction_Request_References)
            ->setNetting_Transaction_Request_Criteria($netting_Transaction_Request_Criteria)
            ->setResponse_Filter($response_Filter)
            ->setResponse_Group($response_Group)
            ->setResponse_Results($response_Results)
            ->setResponse_Data($response_Data)
            ->setVersion($version);
    }
    /**
     * Get Netting_Transaction_Request_References value
     * @return \StructType\Netting_Transaction_Request_ReferencesType|null
     */
    public function getNetting_Transaction_Request_References()
    {
        return $this->Netting_Transaction_Request_References;
    }
    /**
     * Set Netting_Transaction_Request_References value
     * @param \StructType\Netting_Transaction_Request_ReferencesType $netting_Transaction_Request_References
     * @return \StructType\Get_Netting_Transactions_ResponseType
     */
    public function setNetting_Transaction_Request_References(\StructType\Netting_Transaction_Request_ReferencesType $netting_Transaction_Request_References = null)
    {
        $this->Netting_Transaction_Request_References = $netting_Transaction_Request_References;
        return $this;
    }
    /**
     * Get Netting_Transaction_Request_Criteria value
     * @return \StructType\Netting_Transaction_Request_CriteriaType|null
     */
    public function getNetting_Transaction_Request_Criteria()
    {
        return $this->Netting_Transaction_Request_Criteria;
    }
    /**
     * Set Netting_Transaction_Request_Criteria value
     * @param \StructType\Netting_Transaction_Request_CriteriaType $netting_Transaction_Request_Criteria
     * @return \StructType\Get_Netting_Transactions_ResponseType
     */
    public function setNetting_Transaction_Request_Criteria(\StructType\Netting_Transaction_Request_CriteriaType $netting_Transaction_Request_Criteria = null)
    {
        $this->Netting_Transaction_Request_Criteria = $netting_Transaction_Request_Criteria;
        return $this;
    }
    /**
     * Get Response_Filter value
     * @return \StructType\Response_FilterType|null
     */
    public function getResponse_Filter()
    {
        return $this->Response_Filter;
    }
    /**
     * Set Response_Filter value
     * @param \StructType\Response_FilterType $response_Filter
     * @return \StructType\Get_Netting_Transactions_ResponseType
     */
    public function setResponse_Filter(\StructType\Response_FilterType $response_Filter = null)
    {
        $this->Response_Filter = $response_Filter;
        return $this;
    }
    /**
     * Get Response_Group value
     * @return \StructType\Netting_Transaction_Response_GroupType|null
     */
    public function getResponse_Group()
    {
        return $this->Response_Group;
    }
    /**
     * Set Response_Group value
     * @param \StructType\Netting_Transaction_Response_GroupType $response_Group
     * @return \StructType\Get_Netting_Transactions_ResponseType
     */
    public function setResponse_Group(\StructType\Netting_Transaction_Response_GroupType $response_Group = null)
    {
        $this->Response_Group = $response_Group;
        return $this;
    }
    /**
     * Get Response_Results value
     * @return \StructType\Response_ResultsType|null
     */
    public function getResponse_Results()
    {
        return $this->Response_Results;
    }
    /**
     * Set Response_Results value
     * @param \StructType\Response_ResultsType $response_Results
     * @return \StructType\Get_Netting_Transactions_ResponseType
     */
    public function setResponse_Results(\StructType\Response_ResultsType $response_Results = null)
    {
        $this->Response_Results = $response_Results;
        return $this;
    }
    /**
     * Get Response_Data value
     * @return \StructType\Netting_Transaction_Response_DataType|null
     */
    public function getResponse_Data()
    {
        return $this->Response_Data;
    }
    /**
     * Set Response_Data value
     * @param \StructType\Netting_Transaction_Response_DataType $response_Data
     * @return \StructType\Get_Netting_Transactions_ResponseType
     */
    public function setResponse_Data(\StructType\Netting_Transaction_Response_DataType $response_Data = null)
    {
        $this->Response_Data = $response_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Get_Netting_Transactions_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
