<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Impair_Asset_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Root element for the Response on the Put operation.
 * @subpackage Structs
 */
class Impair_Asset_ResponseType extends AbstractStructBase
{
    /**
     * The Asset_Impairment_Event_Reference
     * Meta information extracted from the WSDL
     * - documentation: A reference to the Asset Impairment Event that was created by the request.
     * - minOccurs: 0
     * @var \StructType\Unique_IdentifierObjectType
     */
    public $Asset_Impairment_Event_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Impair_Asset_ResponseType
     * @uses Impair_Asset_ResponseType::setAsset_Impairment_Event_Reference()
     * @uses Impair_Asset_ResponseType::setVersion()
     * @param \StructType\Unique_IdentifierObjectType $asset_Impairment_Event_Reference
     * @param string $version
     */
    public function __construct(\StructType\Unique_IdentifierObjectType $asset_Impairment_Event_Reference = null, $version = null)
    {
        $this
            ->setAsset_Impairment_Event_Reference($asset_Impairment_Event_Reference)
            ->setVersion($version);
    }
    /**
     * Get Asset_Impairment_Event_Reference value
     * @return \StructType\Unique_IdentifierObjectType|null
     */
    public function getAsset_Impairment_Event_Reference()
    {
        return $this->Asset_Impairment_Event_Reference;
    }
    /**
     * Set Asset_Impairment_Event_Reference value
     * @param \StructType\Unique_IdentifierObjectType $asset_Impairment_Event_Reference
     * @return \StructType\Impair_Asset_ResponseType
     */
    public function setAsset_Impairment_Event_Reference(\StructType\Unique_IdentifierObjectType $asset_Impairment_Event_Reference = null)
    {
        $this->Asset_Impairment_Event_Reference = $asset_Impairment_Event_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Impair_Asset_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
