<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Prepaid_Spend_Amortization_Schedule_Request_ReferencesType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: List all the references to the schedules that should be returned.
 * @subpackage Structs
 */
class Prepaid_Spend_Amortization_Schedule_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Prepaid_Spend_Amortization_Schedule_Reference
     * Meta information extracted from the WSDL
     * - documentation: A set of references to schedules to return.
     * - maxOccurs: unbounded
     * @var \StructType\Prepaid_Spend_Amortization_ScheduleObjectType[]
     */
    public $Prepaid_Spend_Amortization_Schedule_Reference;
    /**
     * Constructor method for
     * Prepaid_Spend_Amortization_Schedule_Request_ReferencesType
     * @uses Prepaid_Spend_Amortization_Schedule_Request_ReferencesType::setPrepaid_Spend_Amortization_Schedule_Reference()
     * @param \StructType\Prepaid_Spend_Amortization_ScheduleObjectType[] $prepaid_Spend_Amortization_Schedule_Reference
     */
    public function __construct(array $prepaid_Spend_Amortization_Schedule_Reference = array())
    {
        $this
            ->setPrepaid_Spend_Amortization_Schedule_Reference($prepaid_Spend_Amortization_Schedule_Reference);
    }
    /**
     * Get Prepaid_Spend_Amortization_Schedule_Reference value
     * @return \StructType\Prepaid_Spend_Amortization_ScheduleObjectType[]|null
     */
    public function getPrepaid_Spend_Amortization_Schedule_Reference()
    {
        return $this->Prepaid_Spend_Amortization_Schedule_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setPrepaid_Spend_Amortization_Schedule_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPrepaid_Spend_Amortization_Schedule_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePrepaid_Spend_Amortization_Schedule_ReferenceForArrayConstraintsFromSetPrepaid_Spend_Amortization_Schedule_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $prepaid_Spend_Amortization_Schedule_Request_ReferencesTypePrepaid_Spend_Amortization_Schedule_ReferenceItem) {
            // validation for constraint: itemType
            if (!$prepaid_Spend_Amortization_Schedule_Request_ReferencesTypePrepaid_Spend_Amortization_Schedule_ReferenceItem instanceof \StructType\Prepaid_Spend_Amortization_ScheduleObjectType) {
                $invalidValues[] = is_object($prepaid_Spend_Amortization_Schedule_Request_ReferencesTypePrepaid_Spend_Amortization_Schedule_ReferenceItem) ? get_class($prepaid_Spend_Amortization_Schedule_Request_ReferencesTypePrepaid_Spend_Amortization_Schedule_ReferenceItem) : sprintf('%s(%s)', gettype($prepaid_Spend_Amortization_Schedule_Request_ReferencesTypePrepaid_Spend_Amortization_Schedule_ReferenceItem), var_export($prepaid_Spend_Amortization_Schedule_Request_ReferencesTypePrepaid_Spend_Amortization_Schedule_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Prepaid_Spend_Amortization_Schedule_Reference property can only contain items of type \StructType\Prepaid_Spend_Amortization_ScheduleObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Prepaid_Spend_Amortization_Schedule_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Prepaid_Spend_Amortization_ScheduleObjectType[] $prepaid_Spend_Amortization_Schedule_Reference
     * @return \StructType\Prepaid_Spend_Amortization_Schedule_Request_ReferencesType
     */
    public function setPrepaid_Spend_Amortization_Schedule_Reference(array $prepaid_Spend_Amortization_Schedule_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($prepaid_Spend_Amortization_Schedule_ReferenceArrayErrorMessage = self::validatePrepaid_Spend_Amortization_Schedule_ReferenceForArrayConstraintsFromSetPrepaid_Spend_Amortization_Schedule_Reference($prepaid_Spend_Amortization_Schedule_Reference))) {
            throw new \InvalidArgumentException($prepaid_Spend_Amortization_Schedule_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Prepaid_Spend_Amortization_Schedule_Reference = $prepaid_Spend_Amortization_Schedule_Reference;
        return $this;
    }
    /**
     * Add item to Prepaid_Spend_Amortization_Schedule_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Prepaid_Spend_Amortization_ScheduleObjectType $item
     * @return \StructType\Prepaid_Spend_Amortization_Schedule_Request_ReferencesType
     */
    public function addToPrepaid_Spend_Amortization_Schedule_Reference(\StructType\Prepaid_Spend_Amortization_ScheduleObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Prepaid_Spend_Amortization_ScheduleObjectType) {
            throw new \InvalidArgumentException(sprintf('The Prepaid_Spend_Amortization_Schedule_Reference property can only contain items of type \StructType\Prepaid_Spend_Amortization_ScheduleObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Prepaid_Spend_Amortization_Schedule_Reference[] = $item;
        return $this;
    }
}
