<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Project_Portfolio_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Put Project Portfolio Top Level Response Element.
 * @subpackage Structs
 */
class Put_Project_Portfolio_ResponseType extends AbstractStructBase
{
    /**
     * The Project_Portfolio_Reference
     * Meta information extracted from the WSDL
     * - documentation: Project Portfolio Reference for Put Project Portfolio Web Service Task.
     * - minOccurs: 0
     * @var \StructType\Project_PortfolioObjectType
     */
    public $Project_Portfolio_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Project_Portfolio_ResponseType
     * @uses Put_Project_Portfolio_ResponseType::setProject_Portfolio_Reference()
     * @uses Put_Project_Portfolio_ResponseType::setVersion()
     * @param \StructType\Project_PortfolioObjectType $project_Portfolio_Reference
     * @param string $version
     */
    public function __construct(\StructType\Project_PortfolioObjectType $project_Portfolio_Reference = null, $version = null)
    {
        $this
            ->setProject_Portfolio_Reference($project_Portfolio_Reference)
            ->setVersion($version);
    }
    /**
     * Get Project_Portfolio_Reference value
     * @return \StructType\Project_PortfolioObjectType|null
     */
    public function getProject_Portfolio_Reference()
    {
        return $this->Project_Portfolio_Reference;
    }
    /**
     * Set Project_Portfolio_Reference value
     * @param \StructType\Project_PortfolioObjectType $project_Portfolio_Reference
     * @return \StructType\Put_Project_Portfolio_ResponseType
     */
    public function setProject_Portfolio_Reference(\StructType\Project_PortfolioObjectType $project_Portfolio_Reference = null)
    {
        $this->Project_Portfolio_Reference = $project_Portfolio_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Project_Portfolio_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
