<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Project_Standard_Cost_Rate_Sheet_ResponseType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: Root element for the Response on the Put operation.
 * @subpackage Structs
 */
class Put_Project_Standard_Cost_Rate_Sheet_ResponseType extends AbstractStructBase
{
    /**
     * The Project_Standard_Cost_Rate_Sheet_Reference
     * Meta information extracted from the WSDL
     * - documentation: Project Role Standard Cost Rate Sheet Reference
     * - minOccurs: 0
     * @var \StructType\Project_Standard_Cost_Rate_SheetObjectType
     */
    public $Project_Standard_Cost_Rate_Sheet_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Project_Standard_Cost_Rate_Sheet_ResponseType
     * @uses Put_Project_Standard_Cost_Rate_Sheet_ResponseType::setProject_Standard_Cost_Rate_Sheet_Reference()
     * @uses Put_Project_Standard_Cost_Rate_Sheet_ResponseType::setVersion()
     * @param \StructType\Project_Standard_Cost_Rate_SheetObjectType $project_Standard_Cost_Rate_Sheet_Reference
     * @param string $version
     */
    public function __construct(\StructType\Project_Standard_Cost_Rate_SheetObjectType $project_Standard_Cost_Rate_Sheet_Reference = null, $version = null)
    {
        $this
            ->setProject_Standard_Cost_Rate_Sheet_Reference($project_Standard_Cost_Rate_Sheet_Reference)
            ->setVersion($version);
    }
    /**
     * Get Project_Standard_Cost_Rate_Sheet_Reference value
     * @return \StructType\Project_Standard_Cost_Rate_SheetObjectType|null
     */
    public function getProject_Standard_Cost_Rate_Sheet_Reference()
    {
        return $this->Project_Standard_Cost_Rate_Sheet_Reference;
    }
    /**
     * Set Project_Standard_Cost_Rate_Sheet_Reference value
     * @param \StructType\Project_Standard_Cost_Rate_SheetObjectType $project_Standard_Cost_Rate_Sheet_Reference
     * @return \StructType\Put_Project_Standard_Cost_Rate_Sheet_ResponseType
     */
    public function setProject_Standard_Cost_Rate_Sheet_Reference(\StructType\Project_Standard_Cost_Rate_SheetObjectType $project_Standard_Cost_Rate_Sheet_Reference = null)
    {
        $this->Project_Standard_Cost_Rate_Sheet_Reference = $project_Standard_Cost_Rate_Sheet_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Project_Standard_Cost_Rate_Sheet_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
