<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Supplier_Invoice_Line_Additional_Data_ResponseType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains the Supplier Invoice Line additional data.
 * @subpackage Structs
 */
class Put_Supplier_Invoice_Line_Additional_Data_ResponseType extends AbstractStructBase
{
    /**
     * The Supplier_Invoice_Line_Reference
     * Meta information extracted from the WSDL
     * - documentation: The Supplier Invoice Line reference
     * - minOccurs: 0
     * @var \StructType\Supplier_Invoice_LineObjectType
     */
    public $Supplier_Invoice_Line_Reference;
    /**
     * The Business_Object_Additional_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Non_Effective_Dated_Web_Service_Additional_DataType
     */
    public $Business_Object_Additional_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Supplier_Invoice_Line_Additional_Data_ResponseType
     * @uses Put_Supplier_Invoice_Line_Additional_Data_ResponseType::setSupplier_Invoice_Line_Reference()
     * @uses Put_Supplier_Invoice_Line_Additional_Data_ResponseType::setBusiness_Object_Additional_Data()
     * @uses Put_Supplier_Invoice_Line_Additional_Data_ResponseType::setVersion()
     * @param \StructType\Supplier_Invoice_LineObjectType $supplier_Invoice_Line_Reference
     * @param \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data
     * @param string $version
     */
    public function __construct(\StructType\Supplier_Invoice_LineObjectType $supplier_Invoice_Line_Reference = null, \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data = null, $version = null)
    {
        $this
            ->setSupplier_Invoice_Line_Reference($supplier_Invoice_Line_Reference)
            ->setBusiness_Object_Additional_Data($business_Object_Additional_Data)
            ->setVersion($version);
    }
    /**
     * Get Supplier_Invoice_Line_Reference value
     * @return \StructType\Supplier_Invoice_LineObjectType|null
     */
    public function getSupplier_Invoice_Line_Reference()
    {
        return $this->Supplier_Invoice_Line_Reference;
    }
    /**
     * Set Supplier_Invoice_Line_Reference value
     * @param \StructType\Supplier_Invoice_LineObjectType $supplier_Invoice_Line_Reference
     * @return \StructType\Put_Supplier_Invoice_Line_Additional_Data_ResponseType
     */
    public function setSupplier_Invoice_Line_Reference(\StructType\Supplier_Invoice_LineObjectType $supplier_Invoice_Line_Reference = null)
    {
        $this->Supplier_Invoice_Line_Reference = $supplier_Invoice_Line_Reference;
        return $this;
    }
    /**
     * Get Business_Object_Additional_Data value
     * @return \StructType\Non_Effective_Dated_Web_Service_Additional_DataType|null
     */
    public function getBusiness_Object_Additional_Data()
    {
        return $this->Business_Object_Additional_Data;
    }
    /**
     * Set Business_Object_Additional_Data value
     * @param \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data
     * @return \StructType\Put_Supplier_Invoice_Line_Additional_Data_ResponseType
     */
    public function setBusiness_Object_Additional_Data(\StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data = null)
    {
        $this->Business_Object_Additional_Data = $business_Object_Additional_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Supplier_Invoice_Line_Additional_Data_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
