<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Resource_Plan_TemplateType StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains all resource plan template references and data.
 * @subpackage Structs
 */
class Resource_Plan_TemplateType extends AbstractStructBase
{
    /**
     * The Resource_Plan_Template_Reference
     * Meta information extracted from the WSDL
     * - documentation: The instance of a resource plan template.
     * - minOccurs: 0
     * @var \StructType\Project_Resource_Plan_TemplateObjectType
     */
    public $Resource_Plan_Template_Reference;
    /**
     * The Resource_Plan_Template_Data
     * Meta information extracted from the WSDL
     * - documentation: Contains the detailed information about a resource plan template.
     * - minOccurs: 0
     * @var \StructType\Resource_Plan_Template_DataType
     */
    public $Resource_Plan_Template_Data;
    /**
     * Constructor method for Resource_Plan_TemplateType
     * @uses Resource_Plan_TemplateType::setResource_Plan_Template_Reference()
     * @uses Resource_Plan_TemplateType::setResource_Plan_Template_Data()
     * @param \StructType\Project_Resource_Plan_TemplateObjectType $resource_Plan_Template_Reference
     * @param \StructType\Resource_Plan_Template_DataType $resource_Plan_Template_Data
     */
    public function __construct(\StructType\Project_Resource_Plan_TemplateObjectType $resource_Plan_Template_Reference = null, \StructType\Resource_Plan_Template_DataType $resource_Plan_Template_Data = null)
    {
        $this
            ->setResource_Plan_Template_Reference($resource_Plan_Template_Reference)
            ->setResource_Plan_Template_Data($resource_Plan_Template_Data);
    }
    /**
     * Get Resource_Plan_Template_Reference value
     * @return \StructType\Project_Resource_Plan_TemplateObjectType|null
     */
    public function getResource_Plan_Template_Reference()
    {
        return $this->Resource_Plan_Template_Reference;
    }
    /**
     * Set Resource_Plan_Template_Reference value
     * @param \StructType\Project_Resource_Plan_TemplateObjectType $resource_Plan_Template_Reference
     * @return \StructType\Resource_Plan_TemplateType
     */
    public function setResource_Plan_Template_Reference(\StructType\Project_Resource_Plan_TemplateObjectType $resource_Plan_Template_Reference = null)
    {
        $this->Resource_Plan_Template_Reference = $resource_Plan_Template_Reference;
        return $this;
    }
    /**
     * Get Resource_Plan_Template_Data value
     * @return \StructType\Resource_Plan_Template_DataType|null
     */
    public function getResource_Plan_Template_Data()
    {
        return $this->Resource_Plan_Template_Data;
    }
    /**
     * Set Resource_Plan_Template_Data value
     * @param \StructType\Resource_Plan_Template_DataType $resource_Plan_Template_Data
     * @return \StructType\Resource_Plan_TemplateType
     */
    public function setResource_Plan_Template_Data(\StructType\Resource_Plan_Template_DataType $resource_Plan_Template_Data = null)
    {
        $this->Resource_Plan_Template_Data = $resource_Plan_Template_Data;
        return $this;
    }
}
