<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Spend_CategoryType StructType
 * Meta information extracted from the WSDL
 * - documentation: Wrapper Element that includes Spend Category Instance and Data
 * @subpackage Structs
 */
class Spend_CategoryType extends AbstractStructBase
{
    /**
     * The Resource_Category_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Spend Category
     * - minOccurs: 0
     * @var \StructType\Spend_CategoryObjectType
     */
    public $Resource_Category_Reference;
    /**
     * The Resource_Category_Data
     * Meta information extracted from the WSDL
     * - documentation: Spend Category Data
     * - minOccurs: 0
     * @var \StructType\Spend_Category_DataType
     */
    public $Resource_Category_Data;
    /**
     * Constructor method for Spend_CategoryType
     * @uses Spend_CategoryType::setResource_Category_Reference()
     * @uses Spend_CategoryType::setResource_Category_Data()
     * @param \StructType\Spend_CategoryObjectType $resource_Category_Reference
     * @param \StructType\Spend_Category_DataType $resource_Category_Data
     */
    public function __construct(\StructType\Spend_CategoryObjectType $resource_Category_Reference = null, \StructType\Spend_Category_DataType $resource_Category_Data = null)
    {
        $this
            ->setResource_Category_Reference($resource_Category_Reference)
            ->setResource_Category_Data($resource_Category_Data);
    }
    /**
     * Get Resource_Category_Reference value
     * @return \StructType\Spend_CategoryObjectType|null
     */
    public function getResource_Category_Reference()
    {
        return $this->Resource_Category_Reference;
    }
    /**
     * Set Resource_Category_Reference value
     * @param \StructType\Spend_CategoryObjectType $resource_Category_Reference
     * @return \StructType\Spend_CategoryType
     */
    public function setResource_Category_Reference(\StructType\Spend_CategoryObjectType $resource_Category_Reference = null)
    {
        $this->Resource_Category_Reference = $resource_Category_Reference;
        return $this;
    }
    /**
     * Get Resource_Category_Data value
     * @return \StructType\Spend_Category_DataType|null
     */
    public function getResource_Category_Data()
    {
        return $this->Resource_Category_Data;
    }
    /**
     * Set Resource_Category_Data value
     * @param \StructType\Spend_Category_DataType $resource_Category_Data
     * @return \StructType\Spend_CategoryType
     */
    public function setResource_Category_Data(\StructType\Spend_Category_DataType $resource_Category_Data = null)
    {
        $this->Resource_Category_Data = $resource_Category_Data;
        return $this;
    }
}
