<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Supplier_Invoice_Assignment_Rule_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: This element contains the specific instance set containing the requested Supplier Invoice Assignment Rule.
 * @subpackage Structs
 */
class Supplier_Invoice_Assignment_Rule_ReferencesType extends AbstractStructBase
{
    /**
     * The Supplier_Invoice_Assignment_Rule_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to supplier invoice assignment rule.
     * - maxOccurs: unbounded
     * @var \StructType\Supplier_Invoice_Assignment_RuleObjectType[]
     */
    public $Supplier_Invoice_Assignment_Rule_Reference;
    /**
     * Constructor method for Supplier_Invoice_Assignment_Rule_ReferencesType
     * @uses Supplier_Invoice_Assignment_Rule_ReferencesType::setSupplier_Invoice_Assignment_Rule_Reference()
     * @param \StructType\Supplier_Invoice_Assignment_RuleObjectType[] $supplier_Invoice_Assignment_Rule_Reference
     */
    public function __construct(array $supplier_Invoice_Assignment_Rule_Reference = array())
    {
        $this
            ->setSupplier_Invoice_Assignment_Rule_Reference($supplier_Invoice_Assignment_Rule_Reference);
    }
    /**
     * Get Supplier_Invoice_Assignment_Rule_Reference value
     * @return \StructType\Supplier_Invoice_Assignment_RuleObjectType[]|null
     */
    public function getSupplier_Invoice_Assignment_Rule_Reference()
    {
        return $this->Supplier_Invoice_Assignment_Rule_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setSupplier_Invoice_Assignment_Rule_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSupplier_Invoice_Assignment_Rule_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSupplier_Invoice_Assignment_Rule_ReferenceForArrayConstraintsFromSetSupplier_Invoice_Assignment_Rule_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $supplier_Invoice_Assignment_Rule_ReferencesTypeSupplier_Invoice_Assignment_Rule_ReferenceItem) {
            // validation for constraint: itemType
            if (!$supplier_Invoice_Assignment_Rule_ReferencesTypeSupplier_Invoice_Assignment_Rule_ReferenceItem instanceof \StructType\Supplier_Invoice_Assignment_RuleObjectType) {
                $invalidValues[] = is_object($supplier_Invoice_Assignment_Rule_ReferencesTypeSupplier_Invoice_Assignment_Rule_ReferenceItem) ? get_class($supplier_Invoice_Assignment_Rule_ReferencesTypeSupplier_Invoice_Assignment_Rule_ReferenceItem) : sprintf('%s(%s)', gettype($supplier_Invoice_Assignment_Rule_ReferencesTypeSupplier_Invoice_Assignment_Rule_ReferenceItem), var_export($supplier_Invoice_Assignment_Rule_ReferencesTypeSupplier_Invoice_Assignment_Rule_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Supplier_Invoice_Assignment_Rule_Reference property can only contain items of type \StructType\Supplier_Invoice_Assignment_RuleObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Supplier_Invoice_Assignment_Rule_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Supplier_Invoice_Assignment_RuleObjectType[] $supplier_Invoice_Assignment_Rule_Reference
     * @return \StructType\Supplier_Invoice_Assignment_Rule_ReferencesType
     */
    public function setSupplier_Invoice_Assignment_Rule_Reference(array $supplier_Invoice_Assignment_Rule_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($supplier_Invoice_Assignment_Rule_ReferenceArrayErrorMessage = self::validateSupplier_Invoice_Assignment_Rule_ReferenceForArrayConstraintsFromSetSupplier_Invoice_Assignment_Rule_Reference($supplier_Invoice_Assignment_Rule_Reference))) {
            throw new \InvalidArgumentException($supplier_Invoice_Assignment_Rule_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Supplier_Invoice_Assignment_Rule_Reference = $supplier_Invoice_Assignment_Rule_Reference;
        return $this;
    }
    /**
     * Add item to Supplier_Invoice_Assignment_Rule_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Supplier_Invoice_Assignment_RuleObjectType $item
     * @return \StructType\Supplier_Invoice_Assignment_Rule_ReferencesType
     */
    public function addToSupplier_Invoice_Assignment_Rule_Reference(\StructType\Supplier_Invoice_Assignment_RuleObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Supplier_Invoice_Assignment_RuleObjectType) {
            throw new \InvalidArgumentException(sprintf('The Supplier_Invoice_Assignment_Rule_Reference property can only contain items of type \StructType\Supplier_Invoice_Assignment_RuleObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Supplier_Invoice_Assignment_Rule_Reference[] = $item;
        return $this;
    }
}
